package model

import (
	"encoding/json"
	"errors"
	"fmt"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/systempreferenceCC/logger"
)

func (obj *FieldConstraintsList) Save(stub chaincode.StubInterfaceAdapter) error {
	jsonRecordLockFunds, err := json.Marshal(obj)
	if err != nil {
		errMsg := fmt.Sprintf("failed to marhsal FieldConstraintsList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	logger.Get().Debugf("save field FieldConstraintsList by key: %s", FieldConstraintsKey)
	err = stub.PutState(FieldConstraintsKey, jsonRecordLockFunds)
	if err != nil {
		errMsg := fmt.Sprintf("failed to add new FieldConstraintsList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	return nil
}

func (obj *EnabledCryptoCurrencyList) Save(stub chaincode.StubInterfaceAdapter) error {
	jsonRecordLockFunds, err := json.Marshal(obj)
	if err != nil {
		errMsg := fmt.Sprintf("failed to marhsal EnabledCryptoCurrencyList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	logger.Get().Debugf("save EnabledCryptoCurrencyList by key: %s", EnabledCryptoCurrenciesKey)
	err = stub.PutState(EnabledCryptoCurrenciesKey, jsonRecordLockFunds)
	if err != nil {
		errMsg := fmt.Sprintf("failed to add new EnabledCryptoCurrencyList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	return nil
}

func (obj *CryptoCurrencyConstraintsList) Save(stub chaincode.StubInterfaceAdapter) error {
	jsonRecordLockFunds, err := json.Marshal(obj)
	if err != nil {
		errMsg := fmt.Sprintf("failed to marhsal CryptoCurrencyConstraintsList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	logger.Get().Debugf("save CryptoCurrencyConstraintsList by key: %s", CryptoCurrenciesContrainstsKey)
	err = stub.PutState(CryptoCurrenciesContrainstsKey, jsonRecordLockFunds)
	if err != nil {
		errMsg := fmt.Sprintf("failed to add new CryptoCurrencyConstraintsList, error %s", err)
		logger.Get().Error(errMsg)
		return errors.New(errMsg)
	}

	return nil
}
