package function

import (
	"gitlab.smartblocklab.com/smartcontracts/common/security/tools"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"fmt"
	"gitlab.smartblocklab.com/smartcontracts/common/model"
	"errors"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type VerifyUserAccount_Type func(info model.UserAccountInfo, adapter chaincode.StubInterfaceAdapter) error

// checkAccountStatus call account chaincode to verify account status
func VerifyUserAccount_Function(info model.UserAccountInfo, adapter chaincode.StubInterfaceAdapter) error {
	// Check out account status
	resp := tools.SignedInvokeChaincode(adapter, invoke.AccountChannel, invoke.AccountCC, invoke.VerifyUserAccountFunction, info)

	if resp.Status != int32(shim.OK) {
		errMsg := fmt.Sprintf("verification of user id %s, failed due to %s", info.UserID, resp.Message)
		logger.Error(errMsg)
		return errors.New(errMsg)
	}

	return nil
}
