package function

import (
	"gitlab.smartblocklab.com/smartcontracts/common/security/tools"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/model"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
)

type IsOfferApproved_Type func(operationID string, adapter chaincode.StubInterfaceAdapter) bool

func IsOfferApproved_Function(operationID string, adapter chaincode.StubInterfaceAdapter) bool {
	logger.Infof("Invoke: OfferCC.IsOfferApproved {operationID: %s}", operationID)

	isOfferApprovedArg := model.IsOfferApprovedArg{
		OperationID: operationID,
	}

	resp := tools.SignedInvokeChaincode(adapter, invoke.OfferChannel, invoke.OfferCC, invoke.IsOfferApprovedFunction, isOfferApprovedArg)
	return resp.Status == int32(shim.OK)
}