package imarket

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/market"
	"gitlab.smartblocklab.com/smartcontracts/common/security/requests"
)

type IMarketManager interface {
	DepositFunds(userID string, inputMarketFoundsObject market.UIDepositFunds, operationID requests.Id) (*market.MarketTransaction, error)

	GetBalance(balanceArg market.MarketArg) (*market.MarketBalance, error)

	WithdrawalFunds(userID string, arg market.UIMarketWithdrawal, operationID requests.Id) (*market.MarketTransactionList, error)

	CreateOrder(userID string, marketOrder market.UIMarketOrder, operationID requests.Id) (*market.MarketTransactionList, error)

	GetAllOrders() (*market.PlainMarketOrderList, error)

	GetUserOrders(arg requests.Id) (*market.PlainMarketOrderList, error)

	CancelOrder(userID string, id requests.Id) (*market.MarketTransactionList, error)

	MatchOrders() (*market.TransactionList, error)

	FindOutgoingTransactions(arg market.FindMarketTransactionArg) (*market.MarketTransactionList, error)

	FindIncomingTransactions(arg market.FindMarketTransactionArg) (*market.MarketTransactionList, error)
}
