package imarketaccount

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/marketaccount"
	"gitlab.smartblocklab.com/smartcontracts/common/security/requests"
)

type IMarketaccountCC interface {
	AddWallet(UserID string, newWalletUISigned marketaccount.NewWallet, walletId requests.Id) (*marketaccount.Wallet, error)
	AddAccount(UserID string, newAccountUISigned marketaccount.NewAccount, accountId requests.Id) (*marketaccount.Account, error)
	AddExternalAccount(UserID string, newExternalAccount marketaccount.NewExternalAccount, subAccountId requests.Id) (*marketaccount.Account, error)
	ActivateWallet(UserID string, walletId requests.Id) (*marketaccount.Wallet, error)
	BlockWallet(UserID string, walletId requests.Id) (*marketaccount.Wallet, error)
	ActivateAccount(UserID string, accountId requests.Id) (*marketaccount.Account, error)
	BlockAccount(UserID string, accountId requests.Id) (*marketaccount.Account, error)
	GetAccountByCurrencyType(arg marketaccount.GetAccountByCurrencyTypeArg) (*marketaccount.Account, error)
	VerifyUserAccount(arg marketaccount.AccountInfo) (*marketaccount.Account, error)
	CheckAndLoadAccount(arg marketaccount.AccountInfo) (*marketaccount.Account, error)
	GetAllUserWallets(userId requests.Id) (*marketaccount.WalletsEnvelope, error)
	GetAccountInfoByAccountID(accountId requests.Id) (*marketaccount.AccountInfo, error)
	GetAccounts(userId requests.Id) (*marketaccount.AccountsEnvelope, error)
	GetWallets(userId requests.Id) (*marketaccount.WalletsEnvelope, error)
}
