package market

import "fmt"

func (obj *MarketTransaction) RecordKey(outUserId, inUserId string, seed int) string {
	return fmt.Sprintf("%s_%s_%s_%d_%d", obj.Amount.CurrencyType, outUserId, inUserId, seed, obj.Timestamp)
}

func InMarketKey(userId, accountId, currencyType string) string {
	return fmt.Sprintf("in.%s.%s.%s", currencyType, userId, accountId)
}

func OutMarketKey(userId, accountId, currencyType string) string {
	return fmt.Sprintf("out.%s.%s.%s", currencyType, userId, accountId)
}

func (obj *MarketOrder) ObjectKey() string {
	return obj.OperationID
}

func (obj *PlainMarketOrder) RecordKey() string {
	return fmt.Sprintf("%s", obj.OperationID)
}

func (obj *PlainMarketOrder) ObjectKey() string {
	return fmt.Sprintf("%s", obj.OperationID)
}

//====================================================================================================================//

func (obj *OrderTransaction) RecordKey() string {
	return fmt.Sprintf("%d_%s_%s", obj.SessionID, obj.InOrderID, obj.OutOrderID)
}

func (obj *OrderTransaction) ObjectKey() string {
	return fmt.Sprintf("%d.%s.%s", obj.SessionID, obj.InOrderID, obj.OutOrderID)
}
