package market

import (
	"encoding/json"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	pb "github.com/hyperledger/fabric/protos/peer"
	"gitlab.smartblocklab.com/smartcontracts/common/logging"
)

func (obj *MarketTransactionList) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *MarketTransactionList) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketTransactionList, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *MarketTransaction) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *MarketTransaction) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketTransaction, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *MarketBalance) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *MarketBalance) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketBalance, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *PlainMarketOrder) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *PlainMarketOrder) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal PlainMarketOrder, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *OrderTransaction) Marshal() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *OrderTransaction) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal OrderTransaction, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *TransactionList) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *TransactionList) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal TransactionList, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *PlainMarketOrderList) Response() pb.Response {
	return shim.Success(obj.Bytes())
}

func (obj *PlainMarketOrderList) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal PlainMarketOrderList, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}
