package marketaccount

import (
	"encoding/json"
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"github.com/hyperledger/fabric/protos/peer"
	"gitlab.smartblocklab.com/smartcontracts/common/logging"
)

func (obj *Wallet) Response() peer.Response {
	return shim.Success(obj.Bytes())
}

func (obj *Wallet) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketBalance, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *Account) Response() peer.Response {
	return shim.Success(obj.Bytes())
}

func (obj *Account) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketBalance, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *WalletsEnvelope) Response() peer.Response {
	return shim.Success(obj.Bytes())
}

func (obj *WalletsEnvelope) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketBalance, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}

func (obj *AccountInfo) Response() peer.Response {
	return shim.Success(obj.Bytes())
}

func (obj *AccountInfo) Bytes() []byte {
	if b, err := json.Marshal(*obj); err != nil {
		logging.Get().Errorf("failed to marshal MarketBalance, failed due to %s", err.Error())
		return []byte{}
	} else {
		return b
	}
}
