package requests

import "encoding/json"

type Id struct {
	Id     string `json:"id,omitempty"`
	UserId string `json:"user_id,omitempty"`
}

type UserSignature struct {
	R string `json:"r,omitempty"`
	S string `json:"s,omitempty"`
}

type Parameter struct {
	UserID   string          `json:"user_id,omitempty"`
	ActionId int32           `json:"action_id,omitempty"`
	Param    json.RawMessage `json:"param,omitempty"`
}

type Parameters struct {
	UserParams   json.RawMessage `json:"user_params,omitempty"`
	SystemParams json.RawMessage `json:"system_params,omitempty"`
}

type FullSignedRequest struct {
	UserSignature   UserSignature `json:"user_signature,omitempty"`
	SystemSignature UserSignature `json:"system_signature,omitempty"`
	Parameters      Parameters    `json:"parameters,omitempty"`
}

type VerifyUserSignatureArg struct {
	UserID        string        `json:"user_id"`
	Digest        string        `json:"digest"`
	UserSignature UserSignature `json:"signature"`
}

type CCFullSignedRequest struct {
	UserSignature   UserSignature `json:"user_signature,omitempty"`
	SystemSignature UserSignature `json:"system_signature,omitempty"`
	Parameters      CCParameters  `json:"parameters,omitempty"`
}

type CCParameters struct {
	UserParams   CCParameter `json:"user_params,omitempty"`
	SystemParams CCParameter `json:"system_params,omitempty"`
}

type CCParameter struct {
	UserID   string      `json:"user_id,omitempty"`
	ActionId int32         `json:"action_id,omitempty"`
	Param    interface{} `json:"param,omitempty"`
}
